"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconRatingWidgetConfigureComponent = exports.IconRatingWidgetConfigureChange = exports.TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const core_2 = require("@tangential/core");
const i0 = require("@angular/core");
const i1 = require("@angular/common");
const i2 = require("@angular/forms");
const i3 = require("@angular/material/form-field");
const i4 = require("@angular/material/input");
const i5 = require("./icon-rating-widget.component");
function IconRatingWidgetConfigureComponent_ng_container_3_Template(rf, ctx) { if (rf & 1) {
    const _r2 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementContainerStart(0);
    i0.ɵɵelementStart(1, "tanj-icon-rating-widget", 4);
    i0.ɵɵlistener("valueChange", function IconRatingWidgetConfigureComponent_ng_container_3_Template_tanj_icon_rating_widget_valueChange_1_listener($event) { i0.ɵɵrestoreView(_r2); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.defaultValue = $event); })("valueChange", function IconRatingWidgetConfigureComponent_ng_container_3_Template_tanj_icon_rating_widget_valueChange_1_listener() { i0.ɵɵrestoreView(_r2); const ctx_r3 = i0.ɵɵnextContext(); ctx_r3.value = ctx_r3.defaultValue; ctx_r3.valueChange.emit(ctx_r3.value); return i0.ɵɵresetView(ctx_r3.defaultValueChange.emit(ctx_r3.defaultValue)); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(2, "mat-form-field", 1)(3, "input", 5);
    i0.ɵɵlistener("change", function IconRatingWidgetConfigureComponent_ng_container_3_Template_input_change_3_listener() { i0.ɵɵrestoreView(_r2); const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.maxChange.emit(ctx_r4.max)); })("ngModelChange", function IconRatingWidgetConfigureComponent_ng_container_3_Template_input_ngModelChange_3_listener($event) { i0.ɵɵrestoreView(_r2); const ctx_r5 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r5.max = $event); });
    i0.ɵɵelementEnd()();
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("value", ctx_r0.defaultValue)("defaultValue", ctx_r0.defaultValue)("max", ctx_r0.max)("iconFont", ctx_r0.iconFont)("offIconNames", ctx_r0.offIconNames)("onIconNames", ctx_r0.onIconNames)("labelPosition", "before");
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngModel", ctx_r0.max);
} }
/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: (0, core_1.forwardRef)(() => IconRatingWidgetConfigureComponent),
    multi: true
};
class IconRatingWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
exports.IconRatingWidgetConfigureChange = IconRatingWidgetConfigureChange;
class IconRatingWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.offIconNames = [];
        this.onIconNames = [];
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.maxChange = new core_1.EventEmitter(false);
        this.iconFontChange = new core_1.EventEmitter(false);
        this.offIconNamesChange = new core_1.EventEmitter(false);
        this.onIconNamesChange = new core_1.EventEmitter(false);
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new IconRatingWidgetConfigureChange(this, this.value));
    }
    swipeRight(event) {
    }
    swipeLeft(event) {
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
exports.IconRatingWidgetConfigureComponent = IconRatingWidgetConfigureComponent;
IconRatingWidgetConfigureComponent.ɵfac = function IconRatingWidgetConfigureComponent_Factory(t) { return new (t || IconRatingWidgetConfigureComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
IconRatingWidgetConfigureComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: IconRatingWidgetConfigureComponent, selectors: [["tanj-icon-rating-widget-configure"]], hostVars: 3, hostBindings: function IconRatingWidgetConfigureComponent_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", iconFont: "iconFont", offIconNames: "offIconNames", onIconNames: "onIconNames" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxChange: "maxChange", iconFontChange: "iconFontChange", offIconNamesChange: "offIconNamesChange", onIconNamesChange: "onIconNamesChange", change: "change" }, features: [i0.ɵɵProvidersFeature([exports.TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR])], decls: 4, vars: 2, consts: [["flex", "", "layout", "column", "layout-align", "start", 1, "tanj-input-template", "tanj-mode-configure"], ["dividerColor", "accent"], ["matInput", "", "type", "text", "maxlength", "50", "placeholder", "Enter a label for this input", 1, "tanj-input", 3, "ngModel", "change", "ngModelChange"], [4, "ngIf"], ["label", "Default Value", 3, "value", "defaultValue", "max", "iconFont", "offIconNames", "onIconNames", "labelPosition", "valueChange"], ["matInput", "", "type", "number", "placeholder", "Max Rating", "max", "10", 1, "tanj-input", 3, "ngModel", "change", "ngModelChange"]], template: function IconRatingWidgetConfigureComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0)(1, "mat-form-field", 1)(2, "input", 2);
        i0.ɵɵlistener("change", function IconRatingWidgetConfigureComponent_Template_input_change_2_listener() { return ctx.labelChange.emit(ctx.label); })("ngModelChange", function IconRatingWidgetConfigureComponent_Template_input_ngModelChange_2_listener($event) { return ctx.label = $event; });
        i0.ɵɵelementEnd()();
        i0.ɵɵtemplate(3, IconRatingWidgetConfigureComponent_ng_container_3_Template, 4, 8, "ng-container", 3);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngModel", ctx.label);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", ctx.label);
    } }, dependencies: [i1.NgIf, i2.DefaultValueAccessor, i2.NumberValueAccessor, i2.NgControlStatus, i2.MaxLengthValidator, i2.MaxValidator, i2.NgModel, i3.MatFormField, i4.MatInput, i5.IconRatingWidgetComponent], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(IconRatingWidgetConfigureComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-icon-rating-widget-configure',
                template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput
             class="tanj-input"
             type="text"
             maxlength="50"
             placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-icon-rating-widget
        [(value)]="defaultValue"
        (valueChange)="value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)"
        [defaultValue]="defaultValue"
        [max]="max"
        [iconFont]="iconFont"
        [offIconNames]="offIconNames"
        [onIconNames]="onIconNames"
        label="Default Value"
        [labelPosition]="'before'">

      </tanj-icon-rating-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max Rating"
               max="10"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
    </ng-container>
  </div>
                 `,
                providers: [exports.TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }], value: [{
            type: core_1.Input
        }], valueChange: [{
            type: core_1.Output
        }], labelPosition: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], defaultValue: [{
            type: core_1.Input
        }], max: [{
            type: core_1.Input
        }], iconFont: [{
            type: core_1.Input
        }], offIconNames: [{
            type: core_1.Input
        }], onIconNames: [{
            type: core_1.Input
        }], labelChange: [{
            type: core_1.Output
        }], defaultValueChange: [{
            type: core_1.Output
        }], maxChange: [{
            type: core_1.Output
        }], iconFontChange: [{
            type: core_1.Output
        }], offIconNamesChange: [{
            type: core_1.Output
        }], onIconNamesChange: [{
            type: core_1.Output
        }], change: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=icon-rating-widget-configure.component.js.map