"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationPickerWidgetComponent = exports.DurationPickerWidgetChange = exports.TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const dialog_1 = require("@angular/material/dialog");
const core_2 = require("@tangential/core");
const moment = require("moment");
const duration_picker_dialog_1 = require("./duration-picker-dialog");
const duration_picker_state_1 = require("./duration-picker-state");
const i0 = require("@angular/core");
const i1 = require("@angular/material/dialog");
const i2 = require("@angular/common");
function DurationPickerWidgetComponent_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 6);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r0.label);
} }
function DurationPickerWidgetComponent_div_3_ng_container_1_span_1_span_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const field_r5 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(field_r5.separator || ":");
} }
function DurationPickerWidgetComponent_div_3_ng_container_1_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "number");
    i0.ɵɵtemplate(3, DurationPickerWidgetComponent_div_3_ng_container_1_span_1_span_3_Template, 2, 1, "span", 9);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const field_r5 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind2(2, 2, field_r5.value, "2.0-0"));
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngIf", field_r5.next == null ? null : field_r5.next.selected);
} }
function DurationPickerWidgetComponent_div_3_ng_container_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0);
    i0.ɵɵtemplate(1, DurationPickerWidgetComponent_div_3_ng_container_1_span_1_Template, 4, 5, "span", 9);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const field_r5 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", field_r5.selected);
} }
function DurationPickerWidgetComponent_div_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 7);
    i0.ɵɵtemplate(1, DurationPickerWidgetComponent_div_3_ng_container_1_Template, 2, 1, "ng-container", 8);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngForOf", ctx_r1.state.fields);
} }
function DurationPickerWidgetComponent_span_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 10);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r2.label);
} }
function DurationPickerWidgetComponent_span_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 11);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r3.label);
} }
const _c0 = function (a0) { return { "tanj-disabled": a0 }; };
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: (0, core_1.forwardRef)(() => DurationPickerWidgetComponent),
    multi: true
};
class DurationPickerWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
exports.DurationPickerWidgetChange = DurationPickerWidgetChange;
class DurationPickerWidgetComponent {
    constructor(changeDetectorRef, dialog) {
        this.changeDetectorRef = changeDetectorRef;
        this.dialog = dialog;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        /* end Configuration Fields */
        this.max = 10;
        this.showDays = false;
        this.showHours = false;
        this.showMinutes = false;
        this.showSeconds = false;
        this.showMilliseconds = false;
        this.change = new core_1.EventEmitter(false);
        this.state = new duration_picker_state_1.DurationPickerState();
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
        if (changes.value) {
            this.state.setDuration(moment.duration(this.value));
        }
        this.updateFields();
    }
    updateFields() {
        if (this.showDays) {
            this.state.select(core_2.TimeUnits.day);
        }
        if (this.showHours) {
            this.state.select(core_2.TimeUnits.h);
        }
        if (this.showMinutes) {
            this.state.select(core_2.TimeUnits.min);
        }
        if (this.showSeconds) {
            this.state.select(core_2.TimeUnits.s);
        }
        if (this.showMilliseconds) {
            this.state.select(core_2.TimeUnits.ms);
        }
    }
    showEditDialog() {
        const dialogRef = this.dialog.open(duration_picker_dialog_1.DurationPickerDialog, {
            disableClose: true,
            data: { state: this.state }
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (result.success) {
                this.value = result.millis;
                this.changeDetectorRef.detectChanges();
                this.emitChangeEvent();
            }
        });
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DurationPickerWidgetChange(this, this.value));
        this.valueChange.emit(this.value);
        console.log('DurationPickerWidgetComponent', 'emitChangeEvent');
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
exports.DurationPickerWidgetComponent = DurationPickerWidgetComponent;
DurationPickerWidgetComponent.ɵfac = function DurationPickerWidgetComponent_Factory(t) { return new (t || DurationPickerWidgetComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1.MatDialog)); };
DurationPickerWidgetComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: DurationPickerWidgetComponent, selectors: [["tanj-duration-picker-widget"]], hostVars: 3, hostBindings: function DurationPickerWidgetComponent_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", showDays: "showDays", showHours: "showHours", showMinutes: "showMinutes", showSeconds: "showSeconds", showMilliseconds: "showMilliseconds" }, outputs: { valueChange: "valueChange", change: "change" }, features: [i0.ɵɵProvidersFeature([exports.TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR]), i0.ɵɵNgOnChangesFeature], decls: 6, vars: 7, consts: [["flex", "", "layout", "row", "layout-align", "start center", 1, "tanj-input-template", "tanj-mode-edit", 3, "ngClass", "click"], ["class", "tanj-label tanj-icon-rating-widget-label", 4, "ngIf"], ["flex", "", "layout", "column", "layout-align", "start center", 1, "tanj-widget-input"], ["class", "tanj-widget-input", "layout", "row", "layout-align", "start", 4, "ngIf"], ["class", "tanj-label tanj-below", 4, "ngIf"], ["class", "tanj-label tanj-after tanj-icon-rating-widget-label", 4, "ngIf"], [1, "tanj-label", "tanj-icon-rating-widget-label"], ["layout", "row", "layout-align", "start", 1, "tanj-widget-input"], [4, "ngFor", "ngForOf"], [4, "ngIf"], [1, "tanj-label", "tanj-below"], [1, "tanj-label", "tanj-after", "tanj-icon-rating-widget-label"]], template: function DurationPickerWidgetComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵlistener("click", function DurationPickerWidgetComponent_Template_div_click_0_listener() { return ctx.showEditDialog(); });
        i0.ɵɵtemplate(1, DurationPickerWidgetComponent_span_1_Template, 2, 1, "span", 1);
        i0.ɵɵelementStart(2, "div", 2);
        i0.ɵɵtemplate(3, DurationPickerWidgetComponent_div_3_Template, 2, 1, "div", 3);
        i0.ɵɵtemplate(4, DurationPickerWidgetComponent_span_4_Template, 2, 1, "span", 4);
        i0.ɵɵelementEnd();
        i0.ɵɵtemplate(5, DurationPickerWidgetComponent_span_5_Template, 2, 1, "span", 5);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(5, _c0, ctx.disabled));
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "before");
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", !ctx.onlyLabel);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "below");
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "after");
    } }, dependencies: [i2.NgClass, i2.NgForOf, i2.NgIf, i2.DecimalPipe], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DurationPickerWidgetComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-duration-picker-widget',
                template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center"
       (click)="showEditDialog()">
      <span *ngIf="!hideLabel && labelPosition == 'before'"
            class="tanj-label tanj-icon-rating-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="row"
           layout-align="start">

        <ng-container *ngFor="let field of state.fields">
          <span *ngIf="field.selected">{{field.value | number:'2.0-0'}}<span
            *ngIf="field.next?.selected">{{field.separator || ':'}}</span></span>
        </ng-container>

      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after tanj-icon-rating-widget-label">{{label}}</span>
  </div>

                 `,
                providers: [exports.TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }, { type: i1.MatDialog }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }], value: [{
            type: core_1.Input
        }], valueChange: [{
            type: core_1.Output
        }], labelPosition: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], hideLabel: [{
            type: core_1.Input
        }], onlyLabel: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], defaultValue: [{
            type: core_1.Input
        }], max: [{
            type: core_1.Input
        }], showDays: [{
            type: core_1.Input
        }], showHours: [{
            type: core_1.Input
        }], showMinutes: [{
            type: core_1.Input
        }], showSeconds: [{
            type: core_1.Input
        }], showMilliseconds: [{
            type: core_1.Input
        }], change: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=duration-picker-widget.component.js.map